% True system parameters
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%   Thermodynamically Consistent Bayesian Analysis    %%%%%%%%%%%
%%%%%%%%%%%       of Closed Biochemical Reaction Systems        %%%%%%%%%%%
%%%%%%%%%%%            Posterior Mode Rate Estimation           %%%%%%%%%%%
%%%%%%%%%%%         Authors: Jenkinson, Zhong, Goutsias         %%%%%%%%%%%
%%%%%%%%%%%              Last Modified: 11/04/2010              %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%

M = 9;                   % number of reactions
N = 13;                  % number of molecular species

kappaPublished = repmat(0,[M,1]); % set rate constants equal to zero

kappaPublished(1) = 1e-3;
kappaPublished(2) = 33;

kappaPublished(3) = 3e-3;
kappaPublished(4) = 3.84;

kappaPublished(5) = 4.5e-4;
kappaPublished(6) = .09;

kappaPublished(7) = 2.1e-3;
kappaPublished(8) = 12;

kappaPublished(9)  = 1e-3;
kappaPublished(10) = 16.5;

kappaPublished(11) = 1e-3;
kappaPublished(12) = 3.6;

kappaPublished(13) = 4.5e-4;
kappaPublished(14) = 1.8;

kappaPublished(15) = 1.5e-3;
kappaPublished(16) = 78;

kappaPublished(17) = 2.1e-4;
kappaPublished(18) = 24;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Find Wegsheider conditions and impose them on published parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%

[SS,W,permMatN,permMatM,M1,M2] = Wcond(stoich);

[logKappaFeas] = findTrue(log(kappaPublished),W,permMatM);

kappa = exp(logKappaFeas);		 