struct rhs {
	Doub k1,k2,k3,k4,k5,k6,k7,k8,k9,k10,k11,k12,k13,k14,k15,k16,k17,k18;
	rhs(Doub k1s, Doub k2s, Doub k3s, Doub k4s, Doub k5s, Doub k6s, Doub k7s, Doub k8s, Doub k9s, Doub k10s, Doub k11s, Doub k12s, Doub k13s, Doub k14s, Doub k15s, Doub k16s, Doub k17s, Doub k18s) : k1(k1s), k2(k2s), k3(k3s), k4(k4s), k5(k5s), k6(k6s), k7(k7s), k8(k8s), k9(k9s), k10(k10s), k11(k11s), k12(k12s), k13(k13s), k14(k14s), k15(k15s), k16(k16s), k17(k17s), k18(k18s) {}
	void operator() (const Doub t, VecDoub_I &x, VecDoub_O &dxdt){
		dxdt[0]  = -k1*x[0]*x[1]   + k2*x[2]  - k7*x[0]*x[5]  + k8*x[4];
		dxdt[1]  = -k1*x[0]*x[1]   + k2*x[2]  - k5*x[1]*x[3]  + k6*x[5]  - k9*x[1]*x[6]  + k10*x[7];
		dxdt[2]  =  k1*x[0]*x[1]   - k2*x[2]  - k3*x[2]*x[3]  + k4*x[4];
		dxdt[3]  = -k3*x[2]*x[3]   + k4*x[4]  - k5*x[1]*x[3]  + k6*x[5]  - k11*x[3]*x[7] + k12*x[8];
		dxdt[4]  =  k3*x[2]*x[3]   - k4*x[4]  + k7*x[0]*x[5]  - k8*x[4];
		dxdt[5]  =  k5*x[1]*x[3]   - k6*x[5]  - k7*x[0]*x[5]  + k8*x[4]  - k13*x[5]*x[6] + k14*x[8];
        dxdt[6]  = -k9*x[1]*x[6]   + k10*x[7] - k13*x[5]*x[6] + k14*x[8];
        dxdt[7]  =  k9*x[1]*x[6]   - k10*x[7] - k11*x[3]*x[7] + k12*x[8];
        dxdt[8]  =  k11*x[3]*x[7]  - k12*x[8] + k13*x[5]*x[6] - k14*x[8] - k15*x[8]*x[9] + k16*x[10] - k17*x[8]*x[11] + k18*x[12];
        dxdt[9]  = -k15*x[8]*x[9]  + k16*x[10];
        dxdt[10] =  k15*x[8]*x[9]  - k16*x[10];
		dxdt[11] = -k17*x[8]*x[11] + k18*x[12];
		dxdt[12] =  k17*x[8]*x[11] - k18*x[12];
	}

	void jacobian(const Doub t, VecDoub_I &x, VecDoub_O &dfdt, MatDoub_O &dfdx){
		Int n=x.size();
		for (Int i=0;i<n;i++) dfdt[i]=0.0;
		
		dfdx[0][0]  = -k1*x[1]-k7*x[5];
		dfdx[0][1]  = -k1*x[0];
		dfdx[0][2]  =  k2;
		dfdx[0][3]  =  0;
		dfdx[0][4]  =  k8;
		dfdx[0][5]  = -k7*x[0];
        dfdx[0][6]  =  0;
        dfdx[0][7]  =  0;
        dfdx[0][8]  =  0;
        dfdx[0][9]  =  0;
        dfdx[0][10] =  0;
        dfdx[0][11] =  0;
        dfdx[0][12] =  0;

		dfdx[1][0]  = -k1*x[1];
		dfdx[1][1]  = -k1*x[0]-k5*x[3]-k9*x[6];
		dfdx[1][2]  =  k2;
		dfdx[1][3]  = -k5*x[1];
		dfdx[1][4]  =  0;
		dfdx[1][5]  =  k6;
        dfdx[1][6]  = -k9*x[1];
        dfdx[1][7]  =  k10;
        dfdx[1][8]  =  0;
        dfdx[1][9]  =  0;
        dfdx[1][10] =  0;
        dfdx[1][11] =  0;
        dfdx[1][12] =  0;

		dfdx[2][0]  =  k1*x[1];
		dfdx[2][1]  =  k1*x[0];
		dfdx[2][2]  = -k2-k3*x[3];
		dfdx[2][3]  = -k3*x[2];
		dfdx[2][4]  =  k4;
		dfdx[2][5]  =  0;
        dfdx[2][6]  =  0;
        dfdx[2][7]  =  0;
        dfdx[2][8]  =  0;
        dfdx[2][9]  =  0;
        dfdx[2][10] =  0;
        dfdx[2][11] =  0;
        dfdx[2][12] =  0;

		dfdx[3][0]  =  0;
		dfdx[3][1]  = -k5*x[3];
		dfdx[3][2]  = -k3*x[3];
		dfdx[3][3]  = -k3*x[2]-k5*x[1]-k11*x[7];
		dfdx[3][4]  =  k4;
		dfdx[3][5]  =  k6;
        dfdx[3][6]  =  0;
        dfdx[3][7]  = -k11*x[3];
        dfdx[3][8]  =  k12;
        dfdx[3][9]  =  0;
        dfdx[3][10] =  0;
        dfdx[3][11] =  0;
        dfdx[3][12] =  0;

		dfdx[4][0]  =  k7*x[5];
		dfdx[4][1]  =  0;
		dfdx[4][2]  =  k3*x[3];
		dfdx[4][3]  =  k3*x[2];
		dfdx[4][4]  = -k4-k8;
		dfdx[4][5]  =  k7*x[0];
        dfdx[4][6]  =  0;
        dfdx[4][7]  =  0;
        dfdx[4][8]  =  0;
        dfdx[4][9]  =  0;
        dfdx[4][10] =  0;
        dfdx[4][11] =  0;
        dfdx[4][12] =  0;

		dfdx[5][0]  = -k7*x[5];
		dfdx[5][1]  =  k5*x[3];
		dfdx[5][2]  =  0;
		dfdx[5][3]  =  k5*x[1];
		dfdx[5][4]  =  k8;
		dfdx[5][5]  = -k6-k7*x[0]-k13*x[6];
        dfdx[5][6]  = -k13*x[5];
        dfdx[5][7]  =  0;
        dfdx[5][8]  =  k14;
        dfdx[5][9]  =  0;
        dfdx[5][10] =  0;
        dfdx[5][11] =  0;
        dfdx[5][12] =  0;

        dfdx[6][0]  =  0;
		dfdx[6][1]  = -k9*x[6];
		dfdx[6][2]  =  0;
		dfdx[6][3]  =  0;
		dfdx[6][4]  =  0;
		dfdx[6][5]  = -k13*x[6];
        dfdx[6][6]  = -k9*x[1]-k13*x[5];
        dfdx[6][7]  =  k10;
        dfdx[6][8]  =  k14;
        dfdx[6][9]  =  0;
        dfdx[6][10] =  0;
        dfdx[6][11] =  0;
        dfdx[6][12] =  0;

        dfdx[7][0]  =  0;
		dfdx[7][1]  =  k9*x[6];
		dfdx[7][2]  =  0;
		dfdx[7][3]  =  k11*x[7];
		dfdx[7][4]  =  0;
		dfdx[7][5]  =  0;
        dfdx[7][6]  =  k9*x[1];
        dfdx[7][7]  = -k10-k11*x[3];
        dfdx[7][8]  =  k12;
        dfdx[7][9]  =  0;
        dfdx[7][10] =  0;
        dfdx[7][11] =  0;
        dfdx[7][12] =  0;

        dfdx[8][0]  =  0;
		dfdx[8][1]  =  0;
		dfdx[8][2]  =  0;
		dfdx[8][3]  =  k11*x[7];
		dfdx[8][4]  =  0;
		dfdx[8][5]  =  k13*x[6];
        dfdx[8][6]  =  k13*x[5];
        dfdx[8][7]  =  k11*x[3];
        dfdx[8][8]  = -k12-k14-k15*x[9]-k17*x[11];
        dfdx[8][9]  = -k15*x[8];
	    dfdx[8][10] =  k16;
        dfdx[8][11] = -k17*x[8];
		dfdx[8][12] =  k18;

        dfdx[9][0]  =  0;
		dfdx[9][1]  =  0;
		dfdx[9][2]  =  0;
		dfdx[9][3]  =  0;
		dfdx[9][4]  =  0;
		dfdx[9][5]  =  0;
        dfdx[9][6]  =  0;
        dfdx[9][7]  =  0;
        dfdx[9][8]  = -k15*x[9];
		dfdx[9][9]  = -k15*x[8];
        dfdx[9][10] =  k16;
        dfdx[9][11] =  0;
        dfdx[9][12] =  0;
		
		dfdx[10][0]  =  0;
		dfdx[10][1]  =  0;
		dfdx[10][2]  =  0;
		dfdx[10][3]  =  0;
		dfdx[10][4]  =  0;
		dfdx[10][5]  =  0;
        dfdx[10][6]  =  0;
        dfdx[10][7]  =  0;
        dfdx[10][8]  =  k15*x[9];
        dfdx[10][9]  =  k15*x[8];
		dfdx[10][10] = -k16;
        dfdx[10][11] =  0;
        dfdx[10][12] =  0;

		dfdx[11][0]  =  0;
		dfdx[11][1]  =  0;
		dfdx[11][2]  =  0;
		dfdx[11][3]  =  0;
		dfdx[11][4]  =  0;
		dfdx[11][5]  =  0;
        dfdx[11][6]  =  0;
        dfdx[11][7]  =  0;
        dfdx[11][8]  = -k17*x[11];
        dfdx[11][9]  =  0;
        dfdx[11][10] =  0;
		dfdx[11][11] = -k17*x[8];
        dfdx[11][12] =  k18;
   
        dfdx[12][0]  =  0;
		dfdx[12][1]  =  0;
		dfdx[12][2]  =  0;
		dfdx[12][3]  =  0;
		dfdx[12][4]  =  0;
		dfdx[12][5]  =  0;
        dfdx[12][6]  =  0;
        dfdx[12][7]  =  0;
        dfdx[12][8]  =  k17*x[11];
        dfdx[12][9]  =  0;
        dfdx[12][10] =  0;
		dfdx[12][11] =  k17*x[8];
        dfdx[12][12] = -k18;
	}
};