% Forward log-rate prior density
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%   Thermodynamically Consistent Bayesian Analysis    %%%%%%%%%%%
%%%%%%%%%%%       of Closed Biochemical Reaction Systems        %%%%%%%%%%%
%%%%%%%%%%%           Forward log-rate prior density            %%%%%%%%%%%
%%%%%%%%%%%        Authors: Jenkinson, Zhong, Goutsias          %%%%%%%%%%%
%%%%%%%%%%%              Last Modified: 11/04/2010              %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
function p = denskappa(logkappa,logkappa_0,lambda,tau)

p = exp(lambda^2/(2*tau^2))/(2*tau) ...
   *erfc((lambda/tau + (logkappa-logkappa_0)/lambda)/sqrt(2)) ...
   *exp((logkappa-logkappa_0)/tau);