% Plot molecular dynamics
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%   Thermodynamically Consistent Bayesian Analysis    %%%%%%%%%%%
%%%%%%%%%%%       of Closed Biochemical Reaction Systems        %%%%%%%%%%%
%%%%%%%%%%%                  System Simulation                  %%%%%%%%%%%
%%%%%%%%%%%        Authors: Jenkinson, Zhong, Goutsias          %%%%%%%%%%%
%%%%%%%%%%%              Last Modified: 11/04/2010              %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%

close all

set(0,'DefaultAxesLineWidth',2,'DefaultAxesFontSize',14,...
      'DefaultAxesFontWeight','normal');
lnw=2;

figure
plot(t,x(:,1),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_1:  Shc*}');
 saveas(gcf,'../results/x1.fig')
   
figure
plot(t,x(:,2),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_2:  Grb2}');
saveas(gcf,'../results/x2.fig')

figure
plot(t,x(:,3),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_3:  Shc*-Grb2}');
saveas(gcf,'../results/x3.fig')
   
figure
plot(t,x(:,4),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_4:  Sos}');
saveas(gcf,'../results/x4.fig')

figure
plot(t,x(:,5),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_5:  Shc*-Grb2-Sos}');
saveas(gcf,'../results/x5.fig')
   
figure
plot(t,x(:,6),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_6:  Grb2-Sos}');
saveas(gcf,'../results/x6.fig')

figure
plot(t,x(:,7),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell)');
   title('{\bf X_7:  (EGF-EGFR*)2-GAP}');
saveas(gcf,'../results/x7.fig')

figure
plot(t,x(:,8),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_8:  (EGF-EGFR*)2-GAP-Grb2}');
saveas(gcf,'../results/x8.fig')

figure
plot(t,x(:,9),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_9:  (EGF-EGFR*)2-GAP-Grb2-Sos}');
saveas(gcf,'../results/x9.fig')

figure
plot(t,x(:,10),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_{10}:  Ras-GDP}');
saveas(gcf,'../results/x11.fig')

figure
plot(t,x(:,11),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_{11}:  (EGF-EGFR*)2-GAP-Grb2-Sos-Ras-GDP}');
saveas(gcf,'../results/x10.fig')

figure
plot(t,x(:,12),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_{12}:  Ras-GTP*}');
saveas(gcf,'../results/x13.fig')

figure
plot(t,x(:,13),'Color',[1 0 0],'Linewidth',lnw)
   xlabel('time (minutes)');
   ylabel('molecules/cell');
   title('{\bf X_{13}:  (EGF-EGFR*)2-GAP-Grb2-Sos-Ras-GTP}');
saveas(gcf,'../results/x12.fig')